//---------------------------------------------------------------------------
#include "sros.h"
#include "OSCore.h"
#include "device1.h"
#include "3664.h"
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//  LN^[foCXhCo֐ `
//---------------------------------------------------------------------------
/***************************************************

	LN^[foCXhCo֐

 ***************************************************/

static int DevNo;

#define		LCD_RS			0x01
#define		LCD_E			0x02
#define		LCDMASK			0x0C
#define		PORT			IO.PDR1.BYTE

static void wait(int c)
{
	int		i,j;
	for(j=0;j<c;j++)
	{
		for(i=0;i<0x682;i++)	{}
	}
}

//---------------------------------------------------------------------------
//  [U[C^[tF[X
//---------------------------------------------------------------------------
/*==========================================================================
							LCD BYTE o
==========================================================================*/
static void LCDOut8(short rs,short code)
{
	int		stat;
	int		port;

#ifndef TCPP
	port = PORT;					/* ݂PBDޔ */

	if( rs )	stat = (port & LCDMASK) | LCD_RS;
	else		stat = (port & LCDMASK);
	PORT = code | stat | LCD_E;
	PORT = code | stat;
	PORT = port;					/* PBDɕA */
#endif
	wait(4);
}

/*==========================================================================
							LCD BYTE o(4bit)
==========================================================================*/
static void LCDOut4(int rs,int code)
{
	int		stat;
	int		port;
	char	lb,hb;

#ifndef TCPP
	port = PORT;					/* ݂PBDޔ */

	if( rs )	stat = (port & LCDMASK) | LCD_RS;
	else		stat = (port & LCDMASK);

	hb = ((code>>4)&0xf) | stat;
	lb = (code&0xf) | stat;

	PORT = hb | LCD_E;
	PORT = hb;

	PORT = lb | LCD_E;
	PORT = lb;

	PORT = port;					/* PBDɕA */
#endif
}
/*
char GetLCD(void)
{
//	return GetDEV(DevNo);
	return 0;
}

BOOL EmptyReadBufLCD(void)
{
//	return EmptyReadBuf(DevNo);
	return TRUE;
}
*/

void PutLCD(char c)
{
	PutDEV(DevNo, c);
}

BOOL EmptyWriteBufLCD(void)
{
	return EmptyWriteBuf(DevNo);
}

void PrintLCD(char * msg)
{
	PrintDEV(DevNo, msg);
}

void ControlLCD(char * msg)
{

}
//---------------------------------------------------------------------------
//  hCoC^[tF[X
//---------------------------------------------------------------------------
/*
static BOOL RD_Ready(void)
{

}

static char IRQ_Read(void)
{

}
*/

static int LCD_Wait;

static void CtrlLCD(char *Data)
{
	int i;
	char c;

	LCD_Wait= 4;
	i = 0;
	while(Data[i])
	{
		wait(LCD_Wait);
		c = Data[i];
		LCDOut4(0,c);
		if(c == 0x01)
		{
			LCD_Wait= 4;
		}
		else if((c & 0xFE) == 0x02)
		{
			LCD_Wait= 4;
		}
		else
		{
			LCD_Wait= 1;
		}
		i++;
	}
	LCD_Wait= 0;
}

void LocateLCD(int x,int y)
{
	LCDOut4(0,0x80 + y*0x40 + x);
}

static BOOL WR_Ready(void)
{
	return LCD_Wait == 0;
}

static void IRQ_Write(char c)
{
	char cmd[3];

	if(c == '\r')
	{
		LCD_Wait= 1;
		LCDOut4(0,2);
		wait(4);
		LCD_Wait= 0;
	}
	else if(c == '\n')
	{
		LCD_Wait= 1;
		LCDOut4(0,0xC0);
		wait(4);
		LCD_Wait= 0;
	}
	else if(c == '\f')
	{
		LCD_Wait= 1;
		LCDOut4(0,2);
		wait(4);
		LCDOut4(0,1);
		wait(4);
		LCD_Wait= 0;
	}
	else
	{
		LCDOut4(1, c);
	}
}

//---------------------------------------------------------------------------
//  [`
//---------------------------------------------------------------------------
static void InitDEV(void)
{
	int i;
	char ctrldata[] = {0x28, 0x10, 0x0E, 0x06, 0x01, 0x02, 0x00};

	wait(15);
	for(i=0;i<3;i++)
	{
		LCDOut8(0,0x3);
	}
	LCDOut8(0,0x2);
	/* bit4=8/4bit , bit3=1/2line , bit2=large/small */
	/* bit3=Display/Cursor , bit2=Right/Left */
	/* bit2=display , bit1=coursor , bit0=blink */
	/* NA */
	/* J[\z[ */
	CtrlLCD(ctrldata);

}

static void Free(void)
{
	SetDevice(DevNo, 0);
}

void AddLCD(int No)
{
	static DEVICE dev;

	DevNo 				= No;
	dev.Init			= InitDEV;
	dev.Ctrl			= ControlLCD;
	dev.IRQ_ReadDevice 	= 0;
	dev.RD_Ready		= 0;
	dev.IRQ_WriteDevice = IRQ_Write;
	dev.WR_Ready		= WR_Ready;
	dev.Free			= Free;

	SetDevice(DevNo, &dev);

}


