OUTPUT_ARCH(h8300hn)
ENTRY("_start")
MEMORY {
        vectors (r)  : org =0x0000, len =0x34
        rom     (rx) : org =0x0034, len =32k-0x34
        ram     (rw) : org =0xf780, len =0x800
}
SECTIONS {
        .vectors : {
                /* Use something like this to place a specific function's address
                   into the vector table.  */
                /* 0x00 */
                SHORT(ABSOLUTE(_start))
                SHORT(ABSOLUTE(_start))
                SHORT(ABSOLUTE(_start))
                SHORT(ABSOLUTE(_start))
                SHORT(ABSOLUTE(_start))
                SHORT(ABSOLUTE(_start))
                SHORT(ABSOLUTE(_start))
                SHORT(DEFINED(_int_nmi)?ABSOLUTE(_int_nmi):ABSOLUTE(_start))
                /* 0x10 */
                SHORT(DEFINED(_int_trap0)?ABSOLUTE(_int_trap0):ABSOLUTE(_start))
                SHORT(DEFINED(_int_trap1)?ABSOLUTE(_int_trap1):ABSOLUTE(_start))
                SHORT(DEFINED(_int_trap2)?ABSOLUTE(_int_trap2):ABSOLUTE(_start))
                SHORT(DEFINED(_int_trap3)?ABSOLUTE(_int_trap3):ABSOLUTE(_start))
                SHORT(ABSOLUTE(_start))
                SHORT(ABSOLUTE(_start))
                SHORT(DEFINED(_int_irq0)?ABSOLUTE(_int_irq0):ABSOLUTE(_start))
                SHORT(DEFINED(_int_irq1)?ABSOLUTE(_int_irq1):ABSOLUTE(_start))
                /* 0x20 */
                SHORT(DEFINED(_int_irq2)?ABSOLUTE(_int_irq2):ABSOLUTE(_start))
                SHORT(DEFINED(_int_irq3)?ABSOLUTE(_int_irq3):ABSOLUTE(_start))
                SHORT(DEFINED(_int_wkp)?ABSOLUTE(_int_wkp):ABSOLUTE(_start))
                SHORT(DEFINED(_int_timera)?ABSOLUTE(_int_timera):ABSOLUTE(_start))
                SHORT(ABSOLUTE(_start))
                SHORT(DEFINED(_int_timerw)?ABSOLUTE(_int_timerw):ABSOLUTE(_start))
                SHORT(DEFINED(_int_timerv)?ABSOLUTE(_int_timerv):ABSOLUTE(_start))
                SHORT(DEFINED(_int_sci3)?ABSOLUTE(_int_sci3):ABSOLUTE(_start))
                /* 0x30 */
                SHORT(DEFINED(_int_iic)?ABSOLUTE(_int_iic):ABSOLUTE(_start))
                SHORT(DEFINED(_int_ad)?ABSOLUTE(_int_ad):ABSOLUTE(_start))
                }  > vectors
        .text : {
                CREATE_OBJECT_SYMBOLS
                *(.text)
                etext = .;
                } > rom
        .init : {
                *(.init)
                } > rom
        .fini : {
                *(.fini)
                } > rom
        .got : {
                *(.got)
                *(.got.plt)
                } > rom
        .rodata : {
                *(.rodata)
                *(.rodata.*)
                _erodata = .;
                } > rom
        .eh_frame_hdr : {
                *(.eh_frame_hdr)
                } > ram
        .eh_frame : {
                *(.eh_frame)
                } > rom
        .jcr : {
                *(.jcr)
                } > rom
        .tors : {
                __CTOR_LIST__ = .;
                LONG((__CTOR_END__ - __CTOR_LIST__) / 4 - 2)
                ___ctors = . ;
                *(.ctors)
                ___ctors_end = . ;
                LONG(0)
                __CTOR_END__ = .;
                __DTOR_LIST__ = .;
                LONG((__DTOR_END__ - __DTOR_LIST__) / 4 - 2)
                ___dtors = . ;
                *(.dtors)
                ___dtors_end = . ;
                LONG(0)
                __DTOR_END__ = .;
                _mdata = .;
                } > rom
        .data : AT (_mdata) {
                _data = .;
                *(.data)
                *(.data.*)
                *(.tiny)
                _edata = .;
                } > ram
        .gcc_exc : {
                *(.gcc_exc)
                } > rom
        .bss : {
                _bss = . ;
                *(.bss)
                *(COMMON)
                _ebss = . ;
                _end = . ;
                }  >ram
        .stack 0xff7c : {
                 _stack = . ;
                *(.stack)
                }  > ram
        .stab 0 (NOLOAD) : {
                [ .stab ]
                }
        .stabstr 0 (NOLOAD) : {
                [ .stabstr ]
                }
        /DISCARD/ : {
                *(.comment)
        }
}
