//---------------------------------------------------------------------------

#ifndef OSCoreH
#define OSCoreH
//---------------------------------------------------------------------------
#include "sros.h"

#define STD_IN  0
#define STD_OUT 0

#define DEV_RDBUF 0
#define DEV_WRBUF 1

#define LONG_PUSH 30

MSGPROC * GetMsgFromProc(MSG * msg);

typedef void PROC_INIT(void);
typedef void PROC_BUFF(char *);
typedef char PROC_GET(void);
typedef void PROC_PUT(char c);

typedef struct {
	int IN;
	int OUT;
} STDIO;

//---------------------------------------------------------------------------

typedef	struct {
	BYTE Flag;
	long Stack;
	int  IN, OUT;
	THRDPROC * proc;
} BLK;

typedef struct _tag_THRD {
	BYTE Select;
	BYTE Count;
	BLK BLOCK[MAX_THRD];
}THRDDATA;

void ChangeThread(long *sp);

//---------------------------------------------------------------------------
typedef struct _tag_device{
	PROC_INIT * Init;
	PROC_INIT * Free;
	PROC_BUFF * Ctrl;

	PROC_GET  * IRQ_ReadDevice;
	PROC_GET  * RD_Ready;

	PROC_PUT  * IRQ_WriteDevice;
	PROC_GET  * WR_Ready;

	BUF Buffer[2];
} DEVICE;


void SetDevice(int No, DEVICE * Device);
void IRQ_ReadDEV(int No);
void IRQ_WriteDEV(int No);
void PolingDEV(int No);

//---------------------------------------------------------------------------

void SystemTimer(void);
void Timer10mSec(void);
void Timer100mSec(void);

//---------------------------------------------------------------------------

void SW_Ancer(BYTE NO, BYTE mask, BYTE data, BYTE Msg_ON, BYTE Msg_OFF);

#endif
