//---------------------------------------------------------------------------

#ifndef SROSH
#define SROSH
//---------------------------------------------------------------------------
#define NULL 0
#define TRUE -1
#define FALSE 0
typedef char BOOL;
typedef unsigned char BYTE;
typedef unsigned int WORD;

#define MAX_TCB 	4
#define MAX_THRD 	4
#define MAX_DEVICE  4
#define MAX_TIMER	4

#define MAX_MESSAGE 8
#define MAX_BUFFER 32

/*******************************************************

	bZ[WAPI

 *******************************************************/
typedef struct{
	BYTE Message;
	long Data;
} MSGDATA;

typedef struct{
	BYTE top;
	BYTE count;
	MSGDATA buf[MAX_MESSAGE];
} MSG;

typedef MSGPROC(MSG *, BYTE, long);

int SendMessage(MSG * msg, BYTE bMsg, long Data);
BOOL PostMessage(MSG * msg, BYTE bMsg, long Data);
BOOL GetMessage(MSG * msg, MSGDATA * result);
int DefaultProc(MSG * msg, BYTE bMsg, long Data);

/*******************************************************

	Oobt@[API

 *******************************************************/
typedef struct{
	BYTE top;
	BYTE count;
	BYTE buf[MAX_BUFFER];
} BUF;

BOOL PutBuffer(BUF *buf, BYTE data, int size);
BYTE GetBuffer(BUF *buf, int size);

/*******************************************************

	^XNAPI

 *******************************************************/
//#define TCPP


#define MODE_NONE   0
#define MODE_TIMER  1
#define MODE_NORMAL 2
#define MODE_SEQ    3
#define MODE_B_FULL	-1

MSG * MakeTask(MSGPROC * proc, BYTE Flag);
BOOL SetTaskMode(MSGPROC * proc, BYTE Flag);
BYTE GetTaskMode(MSGPROC * proc);
BOOL KillTask(MSG * msg);
MSGPROC * GetMsgFromProc(MSG * msg);
MSG * GetProcFromMsg(MSGPROC * proc);

/*******************************************************

	XbhAPI

 *******************************************************/
 typedef void THRDPROC(void);

 void SleepThread(int Select);
 void TermThread(int Select);
 void ResumeThread(int Select);
 int MakeThread(THRDPROC * proc);
#define CHG_THREAD    asm("trapa #0")

#define DEV1 0
#define DEV2 1
#define DEV3 2
#define DEV4 3
#define DEV5 4
#define DEV6 5
#define DEV7 6
#define DEV8 7

char GetDEV(int No);
void PutDEV(int No, char c);
char EmptyReadBuf(int No);
char EmptyWriteBuf(int No);
void PrintDEV(int No, char * msg);

BOOL SetSTDIN(int No);
BOOL SetSTDOUT(int No);
int GetSTDIN(void);
int GetSTDOUT(void);

void SetLED(char atr, char data);
int SetTimer(MSG * msg, int WaitTime, long data);
void KillTimer(int ID);

#define MAX_CMDCHAR 16

typedef struct{
	int count;
	char text[MAX_CMDCHAR];
} CMD_BUF;

int StrPos(char *data, char *subdata);
int MakeList(char *data, char **list, char sep);
void MakeCmdText(CMD_BUF * COMMAND);
void MakeField(char *data, char **list, int *count);

MSG * GetDefTask(void);
void SetDefTask(MSG *msg);

BOOL IsHex(char * data);
static BYTE HexToDec(char data);
BYTE HexToByte(char * hexdata);
int HexToInt(char * hexdata);
void PutHex(BYTE value);

#define MSG_INIT		1
#define MSG_DESTROY		2
#define MSG_QUIT		3
#define MSG_TIMER		4

#define MSG_AD1FINE 	5
#define MSG_AD2FINE 	6
#define MSG_AD3FINE 	7
#define MSG_AD4FINE 	8
#define MSG_AD5FINE 	9
#define MSG_AD6FINE 	10
#define MSG_AD7FINE 	11
#define MSG_AD8FINE 	12
#define MSG_TIMEUP		13
#define MSG_ONSTDIN		14
#define MSG_THRDTERM 	15
#define MSG_SW1ON		16
#define MSG_SW1OFF		17
#define MSG_SW2ON		18
#define MSG_SW2OFF		19
#define MSG_SW3ON		20
#define MSG_SW3OFF		21
#define MSG_SW4ON		22
#define MSG_SW4OFF		23
#define MSG_SW5ON		24
#define MSG_SW5OFF		25
#define MSG_SW6ON		26
#define MSG_SW6OFF		27
#define MSG_SW7ON		28
#define MSG_SW7OFF		29
#define MSG_SW8ON		30
#define MSG_SW8OFF		31
#define MSG_SW1CLCK		32
#define MSG_SW1DCLK 	33
#define MSG_SW1LONG 	34
#define MSG_SW2CLCK		36
#define MSG_SW2DCLK 	37
#define MSG_SW2LONG 	38
#define MSG_SW3CLCK		40
#define MSG_SW3DCLK 	41
#define MSG_SW3LONG 	42
#define MSG_SW4CLCK		44
#define MSG_SW4DCLK 	45
#define MSG_SW4LONG 	46
#define MSG_SW5CLCK		48
#define MSG_SW5DCLK 	49
#define MSG_SW5LONG 	50
#define MSG_SW6CLCK		52
#define MSG_SW6DCLK 	53
#define MSG_SW6LONG 	54
#define MSG_SW7CLCK		56
#define MSG_SW7DCLK 	57
#define MSG_SW7LONG 	58
#define MSG_SW8CLCK		60
#define MSG_SW8DCLK 	61
#define MSG_SW8LONG 	62
#define MSG_SWLONG		63

#define MSG_COMMAND		64

#endif


