/*---------------------------------------------------------------------------*/
#ifdef TC
#pragma hdrstop
#endif
#include "SROS.h"
#include "AIUnit.h"
/*---------------------------------------------------------------------------*/

struct _tag_AIDATA MouseData;
int count;

BOOL CheckFront(void);
BOOL CheckRight(void);
BOOL CheckLeft(void);

static void CheckMap(void);
static void SetMap(int DIR, int X, int Y);

static BYTE GetFrontSMap(BYTE mapdata, int DIR, int CXP, int CYP);
static BYTE GetRightSMap(BYTE mapdata, int DIR, int CXP, int CYP);
static BYTE GetLeftSMap (BYTE mapdata, int DIR, int CXP, int CYP);
static BYTE GetSMapData(int X, int Y);

static BYTE GetMapData(int X, int Y);
static BYTE GetFrontMap(int DIR, int CXP, int CYP);
static BYTE GetRightMap(int DIR, int CXP, int CYP);
static BYTE GetLeftMap (int DIR, int CXP, int CYP);

#define GX1    MouseData.GDX
#define GX2    MouseData.GDX+1
#define GY1    MouseData.GDY
#define GY2    MouseData.GDY+1

void init_ai(void)
{
	int x,y,i;

	for(x = 0; x < MAP_X; x++)
	for(y = 0; y < MAP_Y; y++)
	{
		MouseData.map[x][y] = 0x00;
	}
	MouseData.X = 0;
	MouseData.Y = 0;
	MouseData.DIR = DIR_N;
	for(i = 0; i < 2; i++)
		MouseData.OCMD[i] = 0;
	count = 0;
}

/*****************************************

	[ɂ킹sLq

 *****************************************/
BYTE Rule(void)
{
	BYTE cmd;
	int X, Y, DIR;

	/* s`hɖ₢킹܂ */
	cmd = AIProc();

	/* `ȟ݂̃}bvʒuA擾 */
	X   =	MouseData.X;
	Y   =	MouseData.Y;
	DIR =	MouseData.DIR;

	/* ̈ʒuS[Ȃ΃S[̏s */
	if((X == MouseData.GX) && (Y == MouseData.GY))
	{
		if (count >= 9) {
			/* s̓S[5AHT4Ō̃S[͒~ */
			cmd = CMD_NOP;
		}
		else if((count & 1) == 1)
		{
			MouseData.GX = GX1;
			MouseData.GY = GY1;
			count++;
			MouseData.AIMode = AIM_TAINIT;
			cmd = CMD_RESTART;
		}
		else if(count == 8)
		{
			MouseData.GX = MouseData.SDX;
			MouseData.GY = MouseData.SDY;
			count++;
			MouseData.AIMode = AIM_TAINIT;
		}
		else
		{
			MouseData.GX = MouseData.SDX;
			MouseData.GY = MouseData.SDY;
			count++;
			MouseData.AIMode = AIM_SAERCH;
		}
		MakeSMap();
	}
	switch(cmd){
	case CMD_MOVEFRONT:
		switch(MouseData.DIR) {
		case DIR_N: Y++; break;
		case DIR_E: X++; break;
		case DIR_S: Y--; break;
		case DIR_W: X--; break;
		}
		break;

	case CMD_TURNLEFT:
		DIR = (DIR-1) & 0x03;
		break;

	case CMD_TURNRIGHT:
		DIR = (DIR+1) & 0x03;
		break;

	case CMD_RESTART:
	case CMD_TURNBACK:
		DIR = (DIR+2) & 0x03;
	}
	MouseData.X = X;
	MouseData.Y = Y;
	MouseData.DIR = DIR;
	return cmd;
}

char GetCMAP(int X, int Y)
{
	return MouseData.smap[X][Y];
}

BYTE AIProc(void)
{
	BYTE cmd,SF,SR,SL,DATA;
	int i, X, Y, DIR;

	X = MouseData.X;
	Y = MouseData.Y;
	DIR = MouseData.DIR;

	if((MouseData.map[X][Y] & 0x80) == 0x00)
	{
/* ߂ėꏊ̏ꍇ͒n}ɕǏ */
		SetMap(DIR, X, Y);
		DATA = MouseData.map[X][Y];
		MouseData.map[X][Y] = DATA  | 0x80;
		CheckMap();
/*	}bv̍쐬 */
		MakeSMap();
	}

/* SMAPϐɏ */
	DATA = MouseData.map[X][Y];
	SF = GetFrontSMap(DATA, DIR, X, Y);
	SR = GetRightSMap(DATA, DIR, X, Y);
	SL = GetLeftSMap (DATA, DIR, X, Y);

/*  葖s̔f[Lq */

	/* ŒZƎvɌ܂B */
	if ((SF <= SL)
	&&  (SF <= SR)
	&&  (SF < 0xFF))
	{
		/* Oi\ZƔ肳ꂽꍇ͑Oi */
		cmd = CMD_MOVEFRONT;
	}
	else
	{
		/* OiȊOǂƔ肳ꂽꍇ͂̕ */
		/* sグ邽QOE]wȂ獶DƂ */
		if (MouseData.OCMD[1] == CMD_TURNRIGHT)
		{
			if(SL <= SR)
			{
				if(SL == 0xFF)
					cmd = CMD_TURNBACK;
				else
					cmd = CMD_TURNLEFT;
			}
			else if(SR < 0xFF)
			{
				cmd = CMD_TURNRIGHT;
			}
		}
		else
		{
			if(SR <= SL)
			{
				if(SR == 0xFF)
					cmd = CMD_TURNBACK;
				else
					cmd = CMD_TURNRIGHT;
			}
			else if(SL < 0xFF)
			{
				cmd = CMD_TURNLEFT;
			}
		}

	}
	MouseData.OCMD[1] = MouseData.OCMD[0];
	MouseData.OCMD[0] = cmd;
	return cmd;
}

/*==========================================================================
							}bv֐
==========================================================================*/
static void SetMapWall(int X, int Y, BYTE data)
{
	if((X > MAP_X-1) | (X < 0) | (Y > MAP_Y-1) | (Y < 0)) return;

	if (data)
	{
		if ((data & MAPW_N) && (Y < MAP_Y-1)) {
			MouseData.map[X  ][Y+1] |= MAPW_S;
		}
		if ((data & MAPW_E) && (X < MAP_X-1)) {
			MouseData.map[X+1][Y  ] |= MAPW_W;
		}
		if ((data & MAPW_S) && (Y >  0)) {
			MouseData.map[X  ][Y-1] |= MAPW_N;
		}
		if ((data & MAPW_W) && (X >  0)) {
			MouseData.map[X-1][Y  ] |= MAPW_E;
		}
		MouseData.map[X][Y] = MouseData.map[X][Y] | data;
	}
	else
		MouseData.map[X][Y] = data;



}

static void SetMap(int DIR, int X, int Y)
{
	MouseData.F = CheckFront();
	MouseData.R = CheckRight();
	MouseData.L = CheckLeft ();

	switch(DIR){
	case DIR_N:
		if(MouseData.F) SetMapWall(X  ,Y  ,MAPW_N);
		if(MouseData.R) SetMapWall(X  ,Y  ,MAPW_E);
		if(MouseData.L) SetMapWall(X  ,Y  ,MAPW_W);
		break;

	case DIR_E:
		if(MouseData.F) SetMapWall(X  ,Y  ,MAPW_E);
		if(MouseData.R) SetMapWall(X  ,Y  ,MAPW_S);
		if(MouseData.L) SetMapWall(X  ,Y  ,MAPW_N);
		break;

	case DIR_S:
		if(MouseData.F) SetMapWall(X  ,Y  ,MAPW_S);
		if(MouseData.R) SetMapWall(X  ,Y  ,MAPW_W);
		if(MouseData.L) SetMapWall(X  ,Y  ,MAPW_E);
		break;

	case DIR_W:
		if(MouseData.F) SetMapWall(X  ,Y  ,MAPW_W);
		if(MouseData.R) SetMapWall(X  ,Y  ,MAPW_N);
		if(MouseData.L) SetMapWall(X  ,Y  ,MAPW_S);
		break;
	}

}

static BYTE GetMapData(int X, int Y)
{
	if((X > MAP_X-1) | (X < 0) | (Y > MAP_Y-1) | (Y < 0)) return 0xFF;
	return MouseData.map[X][Y];
}


static BYTE GetFrontMap(int DIR, int X, int Y)
{
	switch(DIR){
	case DIR_N:
			if(MouseData.map[X][Y] & MAPW_N) return 0xFF;
			else                   return GetMapData( X ,Y+1);

	case DIR_E:
			if(MouseData.map[X][Y] & MAPW_E) return 0xFF;
			else                   return GetMapData(X+1, Y );

	case DIR_S:
			if(MouseData.map[X][Y] & MAPW_S) return 0xFF;
			else                   return GetMapData( X ,Y-1);

	case DIR_W:
			if(MouseData.map[X][Y] & MAPW_W) return 0xFF;
			else                   return GetMapData(X-1, Y );
	}
	return 0xFF;
}

static BYTE GetRightMap(int DIR, int X, int Y)
{
	switch(DIR){
	case DIR_N:
			if(MouseData.map[X][Y] & MAPW_E) return 0xFF;
			else                   return GetMapData(X+1, Y );


	case DIR_E:
			if(MouseData.map[X][Y] & MAPW_S) return 0xFF;
			else                   return GetMapData( X ,Y-1);

	case DIR_S:
			if(MouseData.map[X][Y] & MAPW_W) return 0xFF;
			else                   return GetMapData(X-1, Y );

	case DIR_W:
			if(MouseData.map[X][Y] & MAPW_N) return 0xFF;
			else                   return GetMapData( X ,Y+1);
	}
	return 0xFF;
}

static BYTE GetLeftMap (int DIR, int X, int Y)
{
	switch(DIR){
	case DIR_N:
			if(MouseData.map[X][Y] & MAPW_W) return 0xFF;
			else                   return GetMapData(X-1, Y );

	case DIR_E:
			if(MouseData.map[X][Y] & MAPW_N) return 0xFF;
			else                   return GetMapData( X ,Y+1);

	case DIR_S:
			if(MouseData.map[X][Y] & MAPW_E) return 0xFF;
			else                   return GetMapData(X+1, Y );

	case DIR_W:
			if(MouseData.map[X][Y] & MAPW_S) return 0xFF;
			else                   return GetMapData( X ,Y-1);
	}
	return 0xFF;
}

void CheckMap(void)
{
	int x,y;
	BYTE n,e,s,w;

	for(x = 0; x < MAP_X; x++)
	for(y = 0; y < MAP_Y; y++)
	{
		n = GetMapData(x,y+1);
		e = GetMapData(x+1,y);
		s = GetMapData(x,y-1);
		w = GetMapData(x-1,y);
		if(n & e & s & w & 0x80)
		{
			MouseData.map[x][y] |= 0x80;

		}
    }

}
/*==========================================================================
							}bv֐
==========================================================================*/

static BYTE GetSMapData(int X, int Y)
{
	if((X > MAP_X-1) | (X < 0) | (Y > MAP_Y-1) | (Y < 0)) return 0x7F;
	return MouseData.smap[X][Y];
}

static BYTE GetFrontSMap(BYTE mapdata, int DIR, int X, int Y)
{
	switch(DIR){
	case DIR_N:
			if(mapdata & MAPW_N) return 0xFF;
			else                   return GetSMapData( X ,Y+1);

	case DIR_E:
			if(mapdata & MAPW_E) return 0xFF;
			else                   return GetSMapData(X+1, Y );

	case DIR_S:
			if(mapdata & MAPW_S) return 0xFF;
			else                   return GetSMapData( X ,Y-1);

	case DIR_W:
			if(mapdata & MAPW_W) return 0xFF;
			else                   return GetSMapData(X-1, Y );
	}
	return 0xFF;
}

static BYTE GetRightSMap(BYTE mapdata, int DIR, int X, int Y)
{
	switch(DIR){
	case DIR_N:
			if(mapdata & MAPW_E) return 0xFF;
			else                   return GetSMapData(X+1, Y );


	case DIR_E:
			if(mapdata & MAPW_S) return 0xFF;
			else                   return GetSMapData( X ,Y-1);

	case DIR_S:
			if(mapdata & MAPW_W) return 0xFF;
			else                   return GetSMapData(X-1, Y );

	case DIR_W:
			if(mapdata & MAPW_N) return 0xFF;
			else                   return GetSMapData( X ,Y+1);

	}
	return 0xFF;
}

static BYTE GetLeftSMap (BYTE mapdata, int DIR, int X, int Y)
{
	switch(DIR){
	case DIR_N:
			if(mapdata & MAPW_W) return 0xFF;
			else                   return GetSMapData(X-1, Y );

	case DIR_E:
			if(mapdata & MAPW_N) return 0xFF;
			else                   return GetSMapData( X ,Y+1);

	case DIR_S:
			if(mapdata & MAPW_E) return 0xFF;
			else                   return GetSMapData(X+1, Y );

	case DIR_W:
			if(mapdata & MAPW_S) return 0xFF;
			else                   return GetSMapData( X ,Y-1);
	}
	return 0xFF;
}

void MakeSMap(void)
{
	int x,y,v;
	BYTE data, wall, f, ch;

	for(x = 0; x < MAP_X; x++)
	for(y = 0; y < MAP_Y; y++)
	{
		MouseData.smap[x][y] = 0xFF;
	}
	if (MouseData.GX == GX1) {
		MouseData.smap[GX1][GY1] = 0;
		MouseData.smap[GX1][GY2] = 0;
		MouseData.smap[GX2][GY1] = 0;
		MouseData.smap[GX2][GY2] = 0;
	}
	else
		MouseData.smap[0][0] = 0;

	ch = 0xFF;

	for (v = 1; v < 256; v++)
	{
		f = 0;
		for(x = 0; x < MAP_X; x++)
		for(y = 0; y < MAP_Y; y++)
		{
			if(MouseData.smap[x][y] == v-1)
			{
				f = 1;
				wall = MouseData.map[x][y];

				data = GetSMapData(x+1, y );
				if((data == ch) && ((wall & MAPW_E) == 0))
				{
					MouseData.smap[x+1][ y ] = v;
				}

				data = GetSMapData(x-1, y );
				if((data == ch) && ((wall & MAPW_W) == 0))
				{
					MouseData.smap[x-1][ y ] = v;
				}

				data = GetSMapData( x , y+1);
				if((data == ch) && ((wall & MAPW_N) == 0))
				{
					MouseData.smap[ x ][y+1] = v;
				}

				data = GetSMapData( x ,y-1);
				if((data == ch) && ((wall & MAPW_S) == 0))
				{
					MouseData.smap[ x ][y-1] = v;
				}
			}
		}
		if(f == 0) return;
	}
}


