//---------------------------------------------------------------------------

#include "SROS.h"
#include "BIOS.h"
#include "Shell.h"
#include "job.h"
#include "AIUnit.h"
//---------------------------------------------------------------------------

static void OnCommand(char *command);

#define MSG_EXECUTE 100
#define MSG_FINE	101
#define MSG_STOP	102
#define MSG_NEXT	103
#define MSG_RECOVER 104
#define MSG_RUN	    105

#define MOVE_FRONT   0
#define TURN_RIGHT   1
#define TURN_LEFT    2
#define TURN_BACK    3
#define TURN_RESTART 4

#define DIR_N 0
#define DIR_E 1
#define DIR_S 2
#define DIR_W 3

#define MAX_MAPX 16
#define MAX_MAPY 16

static struct {
	BYTE Timer[MAX_TIMER];
	MSG * Shell;
	MSG * Msg;
	MSG * MOTERMsg;
	int AIThreadNo;
	int Counter;
	BOOL Term;
	int Result;
	BYTE mode;
} Data;

extern struct _tag_AIDATA MouseData;

struct {
	BYTE state;
	BYTE cmd;
	BYTE Timer[MAX_TIMER];
	int X, Y, DIR;
	int GX, GY;
	int Count;
	char data[32];
} MoterData;
/*
	ZT[̓[`

*/
BOOL CheckFront(void)
{
	while(1) if(Data.mode == 1)
	{
		print("CHECK F\n");
		switch(GetCh()){
		case 'T': return TRUE;
		case 'F': return FALSE;
		}
	}
	else
	{
		StartADC(0);
		StartADC(1);

	}
}

BOOL CheckLeft(void)
{
	while(1) if(Data.mode == 1)
	{
		print("CHECK L\n");
		switch(GetCh()){
		case 'T': return TRUE;
		case 'F': return FALSE;
		}
	}
	else
	{
		StartADC(2);

	}
}

BOOL CheckRight(void)
{
	while(1) if(Data.mode == 1)
	{
		print("CHECK R\n");
		switch(GetCh()){
		case 'T': return TRUE;
		case 'F': return FALSE;
		}
	}
	else
	{
		StartADC(3);

	}
}

BOOL Execute(int data)
{
	while(1)
	{
		switch(data){
		case MOVE_FRONT: 	print("MOVE F\n"); break;
		case TURN_LEFT:  	print("TURN L\n"); break;
		case TURN_RIGHT: 	print("TURN R\n"); break;
		case TURN_BACK:  	print("TURN B\n"); break;
		case TURN_RESTART:  print("TURN B\n"); break;
		default:            print("NOP\n");
		}
		switch(GetCh()){
		case 'N': return TRUE;
		case 'Q': return FALSE;
		}
	}
}
/*

	lHm\̃Xbh

*/
void AIThread(void)
{
	int i;
	char cmd, m;
	Data.Term = FALSE;
	MouseData.AIMode = AIM_SAERCH;
	init_ai();
	SleepThread(Data.AIThreadNo);

	while(! Data.Term)
	{
		switch(GetCh()){
		case 'S':

			if((MouseData.GX == MouseData.X) &&
			   (MouseData.GY == MouseData.Y) &&
			   (MouseData.GX == MouseData.SDX))
			{
				MouseData.DIR = (MouseData.DIR ^ 2);
				m = TURN_RESTART;
			}
			else
			{
				cmd = AIProc();

				switch(cmd){
				case CMD_MOVEFRONT:
					switch(MouseData.DIR){
					case DIR_N: MouseData.Y++; break;
					case DIR_E: MouseData.X++; break;
					case DIR_S: MouseData.Y--; break;
					case DIR_W: MouseData.X--; break;
					}
					m = MOVE_FRONT;
					break;

				case CMD_TURNRIGHT:
					MouseData.DIR = ++MouseData.DIR & 0x03;
					m = TURN_RIGHT;
					break;

				case CMD_TURNLEFT:
					MouseData.DIR = --MouseData.DIR & 0x03;
					m = TURN_LEFT;
					break;

				case CMD_TURNBACK:
					MouseData.DIR = (MouseData.DIR ^ 2);
					m = TURN_BACK;
					if((MouseData.GX == MouseData.X) &&
					   (MouseData.GY == MouseData.Y))
					{
					}
					break;
				}
			}

			if((MouseData.GX == MouseData.X) &&
			   (MouseData.GY == MouseData.Y))
			{
				if(m == TURN_RESTART)
				{
					MouseData.AIMode= AIM_TAINIT;
					MouseData.GX	= MouseData.GDX;
					MouseData.GY	= MouseData.GDY;
				}
				else if(MouseData.GX == MouseData.GDX)
				{
					MouseData.AIMode= AIM_SAERCH;
					MouseData.GX	= MouseData.SDX;
					MouseData.GY	= MouseData.SDY;
				}
					MakeSMap();
			}

			if(Data.mode == 1) Execute(m);
			MoterData.cmd = m;
			MoterData.state = 1;

			while (MoterData.state < 2)
			{
				PostMessage(Data.MOTERMsg, MSG_EXECUTE, m);
				CHG_THREAD;
			}
			if(m == TURN_RESTART)
			{
//				SleepThread(Data.AIThreadNo);
			}
			while (MoterData.state < 100)
			{
				CHG_THREAD;
			}
			break;

		case 'Q':
			init_ai();
			PostMessage(Data.MOTERMsg, MSG_INIT, 0);
			break;

		default:
			print('@');
		}
	}
}

void SetMoter(int R, int L)
{

}

int MoveSystem(MSG * msg, BYTE bMsg, long data)
{
	int i, x, y;

	switch(MoterData.state){
	case 2:
		break;

	}

	switch(bMsg){
	case MSG_INIT:
		TermThread(Data.AIThreadNo);
		Data.AIThreadNo		= MakeThread(AIThread);
		Data.MOTERMsg		= msg;

		MoterData.Count 	= 0;
		MoterData.GX  		= MouseData.GDX;
		MoterData.GY  		= MouseData.GDY;
		MoterData.X   		= MouseData.SDX;
		MoterData.Y   		= MouseData.SDY;
		MoterData.DIR 		= DIR_N;

	case MSG_RECOVER:
		MouseData.GX  		= MoterData.GX;
		MouseData.GY  		= MoterData.GY;
		MouseData.X   		= MoterData.X;
		MouseData.Y   		= MoterData.Y;
		MouseData.DIR 		= MoterData.DIR;
		break;

	case MSG_DESTROY:
		TermThread(Data.AIThreadNo);
		break;

	case MSG_SW1CLCK: /*  Start */
		println("Execute");

		break;

	case MSG_SW2CLCK: /*  Stop */
		println("Stop");

		break;

	//  [^[𓮍Ԃɂ܂Bi^C}[荞݂nmj
	case MSG_RUN:
		ResumeThread(Data.AIThreadNo);
		SetDefTask(msg);
		break;

	//  [^[~Ԃɂ܂Bi^C}[荞݂neej
	case MSG_STOP:
		SleepThread(Data.AIThreadNo);
		break;

	//@^CAEgŌĂяo
	case MSG_TIMEUP:
		switch(data){
		case 0:
			KillTimer(Data.Timer[2]);
			break;
		}
		break;

	//  PړIŌĂяo
	case MSG_FINE:
		switch(data){
		case MOVE_FRONT:
			switch((int)MoterData.DIR){
			case DIR_N: MoterData.Y = MoterData.Y + 1; break;
			case DIR_E: MoterData.X = MoterData.X + 1; break;
			case DIR_S: MoterData.Y = MoterData.Y - 1; break;
			case DIR_W: MoterData.X = MoterData.X - 1; break;
			}
			break;

		case TURN_RIGHT:   MoterData.DIR = (MoterData.DIR + 1) & 0x03; break;
		case TURN_LEFT:    MoterData.DIR = (MoterData.DIR - 1) & 0x03; break;
		case TURN_BACK:    MoterData.DIR = (MoterData.DIR - 2) & 0x03; break;
		case TURN_RESTART: MoterData.DIR = (MoterData.DIR - 2) & 0x03; break;
		}

		if(data == TURN_RESTART)
		{
			MoterData.GX = MouseData.GDX;
			MoterData.GY = MouseData.GDY;
			if(++Data.Counter < 5)
			{
				PostMessage(Data.Msg, MSG_FINE, 0);
				ResumeThread(Data.AIThreadNo);
				MoterData.state = 100;
			}
		}
		else
		{
			if((MoterData.GX == MoterData.X) &&
			   (MoterData.GY == MoterData.Y))
			{
				if(MoterData.GX == MouseData.GDX)
				{
					MoterData.GX = MouseData.GX;
					MoterData.GY = MouseData.GY;
				}
			}
			MoterData.state = 100;

		}
		break;

	//  lHm\s߂󂯎obt@[ɒ߂܂B
	case MSG_EXECUTE:
		MoterData.state++;
		if(MoterData.Count < 32)
		{
			if(Data.mode == 1)
			{
				PostMessage(msg, MSG_FINE, data);
			}
			else
			{
				MoterData.data[  MoterData.Count] = data;
				MoterData.data[++MoterData.Count] = 0;
			}
		}
		else
			PostMessage(msg, MSG_EXECUTE, data);
		break;

	//  obt@[̍s̉͂܂B
	case MSG_NEXT:
		MoterData.state++;
		if(StrPos(MoterData.data, "FF") == 0)
		{
			i = 2;
			while(MoterData.data[i]=='F')
			{
				i++;
			}

			i = i-1;
			SetMoter(i,i);

			i = 0;
			do
			{
				i++;
				MoterData.data[i-1] = MoterData.data[i];
			}
			while(MoterData.data[i]);
			MoterData.Count--;
		}
		else if(StrPos(MoterData.data, "FL") == 0)
		{
			if(StrPos(MoterData.data, "FLFRFLFR") == 0)
			{ /* ΂ߑs */

			}
			else if(StrPos(MoterData.data, "FLFRFRFL") == 0)
			{ /* t^[ */

			}
			else if(StrPos(MoterData.data, "FLFR") == 0)
			{

			}
			else if(StrPos(MoterData.data, "FLFL") == 0)
			{

			}
			else if(StrPos(MoterData.data, "FL") == 0)
			{ /*  */

			}

			i = 1;
			do
			{
				i++;
				MoterData.data[i-2] = MoterData.data[i];
			}
			while(MoterData.data[i]);
			MoterData.Count = MoterData.Count- 4;
		}
		else if(StrPos(MoterData.data, "FR") == 0)
		{
			if(StrPos(MoterData.data, "FRFLFRFL") == 0)
			{ /* ΂ߑs */

			}
			else if(StrPos(MoterData.data, "FRFLFLFR") == 0)
			{ /* t^[ */

			}
			else if(StrPos(MoterData.data, "FRFL") == 0)
			{

			}
			else if(StrPos(MoterData.data, "FRFR") == 0)
			{

			}
			else if(StrPos(MoterData.data, "FR") == 0)
			{ /* E */

			}

			i = 1;
			do
			{
				i++;
				MoterData.data[i-2] = MoterData.data[i];
			}
			while(MoterData.data[i]);
			MoterData.Count = MoterData.Count- 4;
		}
		else if(strcmp(MoterData.data, "F") == 0)
		{
			SetMoter(1,1);
		}
		else if(strcmp(MoterData.data, "R") == 0)
		{
			SetMoter(1,-1);
		}
		else if(strcmp(MoterData.data, "L") == 0)
		{
			SetMoter(-1,1);
		}
		else if(strcmp(MoterData.data, "B") == 0)
		{
			SetMoter(2,-2);
		}
		else if(strcmp(MoterData.data, "S") == 0)
		{
			SetMoter(2,-2);
		}
		break;


	default:
		return DefaultProc(msg, bMsg, data);
	}
	return 0;
}

int Job1(MSG * msg, BYTE bMsg, long data)
{
	switch(bMsg){
	case MSG_INIT:
		println("Job 1 Start");
		Data.Msg      = msg;
		Data.Shell    = GetDefTask();
		Data.Counter  = 0;
		Data.mode     = 1;

		MouseData.GDX = 7;
		MouseData.GDY = 7;
		MouseData.SDX = 0;
		MouseData.SDY = 0;

		SetDefTask(msg);
		MakeTask(MoveSystem, MODE_SEQ);
		break;

	case MSG_SW1CLCK: /*  Start */
		println("Execute");
		PostMessage(msg, MSG_EXECUTE, 0);
		break;

	case MSG_SW2CLCK: /*  Stop */
		println("Stop");
		PostMessage(Data.MOTERMsg, MSG_STOP, 0);
		break;

	case MSG_SW1DCLK:
		println("Normal Mode");
		Data.mode = 0;
		break;

	case MSG_SW2DCLK:
		println("Debug Mode");
		Data.mode = 1;
		break;

	case MSG_SW1LONG:
		println("Quit");
		PostMessage(msg, MSG_QUIT, 0);
		break;

	case MSG_SW2LONG:
		println("Map Clear");
		PostMessage(Data.MOTERMsg, MSG_RECOVER, 0);
		break;

	case MSG_TIMEUP:
		switch(data){
		case 0:
			KillTimer(Data.Timer[0]);
			PostMessage(Data.MOTERMsg, MSG_RUN, 0);
			break;

		case 1:
			KillTimer(Data.Timer[1]);
			PostMessage(Data.MOTERMsg, MSG_STOP, 0);
			break;
		}
		break;

	case MSG_EXECUTE:
		Data.Timer[0] = SetTimer(msg, 200, 0);
		break;

	case MSG_FINE:
//		SetDefTask(msg);
		break;

	case MSG_ONSTDIN:
	case MSG_COMMAND:
		PostMessage(Data.Shell, bMsg, data);
		break;


	case MSG_DESTROY:
		println("DESTROY");
		SetDefTask(Data.Shell);
		break;

	default:
		return DefaultProc(msg, bMsg, data);
	}
	return 0;
}


