//---------------------------------------------------------------------------

#include "SROS.h"
#include "BIOS.h"
#include "Shell.h"
#include "string.h"

//---------------------------------------------------------------------------

static void OnCommand(char *command);

static struct {
	BYTE mode;
	BYTE select;
	BYTE Thread;
	BOOL Term;
	BYTE Timer[4];
	CMD_BUF Command;
} Data;

int ShellMain(MSG * msg, BYTE bMsg, long data)
{
	switch(bMsg){
	case MSG_INIT:
		SetLED(3, 0x00);
		break;

	case MSG_SW1CLCK:
		if(++Data.select > 3) Data.select = 0;
		SetLED(8, Data.select);
		Data.Timer[1] = SetTimer(msg, 20, 1);
		break;

	case MSG_SW2CLCK:
		SetLED(8, Data.select);
		Data.Timer[1] = SetTimer(msg, 20, 1);
		switch(Data.select){
		case 0:
			MakeTask(Job1, MODE_NORMAL);
			break;

		case 1:
			MakeTask(Job2, MODE_NORMAL);
			break;

		case 2:
			MakeTask(Job3, MODE_NORMAL);
			break;

		case 3:
			MakeTask(Job4, MODE_NORMAL);
			break;
		}
		break;

	case MSG_TIMEUP:
		KillTimer(Data.Timer[data]);
		SetLED(3, Data.select);
		break;

	case MSG_ONSTDIN:
		MakeCmdText(&Data.Command);
		break;

	case MSG_COMMAND:
		OnCommand(Data.Command.text);
		break;

	default:
		return DefaultProc(msg, bMsg, data);
	}
	return 0;
}

static void OnCommand(char *command)
{
	char * List[4];
	int i;

	MakeList(command, List, ' ');
	if(strcmp(List[0], "HELP")==0)
	{

	}
	else if(strcmp(List[0], "SW1")==0)
	{
		if(strcmp(List[1], "CLCK")==0)
			PostMessage(GetDefTask(), MSG_SW1CLCK, 0);
		else if(strcmp(List[1], "DCLK")==0)
			PostMessage(GetDefTask(), MSG_SW1DCLK, 0);
		else if(strcmp(List[1], "LONG")==0)
			PostMessage(GetDefTask(), MSG_SW1LONG, 0);
	}
	else if(strcmp(List[0], "SW2")==0)
	{
		if(strcmp(List[1], "CLCK")==0)
			PostMessage(GetDefTask(), MSG_SW2CLCK, 0);
		else if(strcmp(List[1], "DCLK")==0)
			PostMessage(GetDefTask(), MSG_SW2DCLK, 0);
		else if(strcmp(List[1], "LONG")==0)
			PostMessage(GetDefTask(), MSG_SW2LONG, 0);
	}
	else if(strcmp(List[0], "SW3")==0)
	{
		if(strcmp(List[1], "CLCK")==0)
			PostMessage(GetDefTask(), MSG_SW3CLCK, 0);
		else if(strcmp(List[1], "DCLK")==0)
			PostMessage(GetDefTask(), MSG_SW3DCLK, 0);
		else if(strcmp(List[1], "LONG")==0)
			PostMessage(GetDefTask(), MSG_SW3LONG, 0);
	}
	else if(strcmp(List[0], "SW4")==0)
	{
		if(strcmp(List[1], "CLCK")==0)
			PostMessage(GetDefTask(), MSG_SW4CLCK, 0);
		else if(strcmp(List[1], "DCLK")==0)
			PostMessage(GetDefTask(), MSG_SW4DCLK, 0);
		else if(strcmp(List[1], "LONG")==0)
			PostMessage(GetDefTask(), MSG_SW4LONG, 0);
	}
	else if(strcmp(List[0], "STDOUT")==0)
	{
		if(strcmp(List[1], "?")==0)
		{
			print("Device No.");
			PutCh('1'+GetSTDOUT());
			println("");
		}
		else if(StrPos(List[1], "DEV")==0)
		{
			i = List[1][3] - '1';
			SetSTDOUT(i);
			if(GetSTDOUT() == i)
				print("Set Device No.");
				PutCh('1'+i);
				println("");
		}
	}
	else if(strcmp(List[0], "STDIN")==0)
	{
		if(strcmp(List[1], "?")==0)
		{
			print("Device No.");
			PutCh('1'+GetSTDIN());
			println("");
		}
		else if(StrPos(List[1], "DEV")==0)
		{
			i = List[1][3] - '1';
			SetSTDIN(i);
			if(GetSTDOUT() == i)
				print("Set Device No.");
				PutCh('1'+i);
				println("");
		}
	}
	else if(strcmp(List[0], "STACK")==0)
	{
		if(strcmp(List[1], "DISP1")==0)
		{
			DispStackMem(1);
		}
	}
	else
	{
		print(command);
		println(" Is Unknown");
	}
}

