//---------------------------------------------------------------------------
#include "sros.h"
#include "shell.h"
#include "Job.h"
#include "OSCore.h"

//---------------------------------------------------------------------------

typedef void ADDDEV(int No);

static void OnStdIn(void);
static void OnCommand(char * COMMAND);

static struct {
	int mode;
	int Term;
	int DevNo;
	ADDDEV * AddDev;
	DEVICE * Device;
	char Data;
	int ThreadNo;

	CMD_BUF CMD;
} JobData;

#define JOB_NONE 0
#define JOB_ADD  1
#define JOB_INIT 2
#define JOB_PUT  3
#define JOB_GET  4
#define JOB_DEL  5

static void DevThread(void)
{
	while(!JobData.Term)
	{
		switch(JobData.mode){
		case JOB_ADD:
			(JobData.AddDev)(JobData.DevNo);
			JobData.mode = JOB_NONE;
			break;

		case JOB_INIT:
			(JobData.Device->Init)();
			JobData.mode = JOB_NONE;
			break;

		case JOB_PUT:
			PutDEV(JobData.DevNo, JobData.Data);
			JobData.mode = JOB_NONE;
			break;

		case JOB_GET:
			JobData.Data = GetDEV(JobData.DevNo);
			JobData.mode = JOB_NONE;
			break;

		case JOB_DEL:
			SetDevice(JobData.DevNo, 0);
			JobData.mode = JOB_NONE;
			break;
		}
	}
}

int Job2(MSG * msg, BYTE Msg, long Data)
{
	MSGDATA cmd;
	static int ID[3], mode;

	if(GetMessage(msg, &cmd))
	switch(cmd.Message){
	case MSG_INIT:
		println("Drivr Checker Start");
		JobData.ThreadNo = MakeThread(DevThread);
		break;

	case MSG_SW1CLCK:
		mode = (mode + 1) & 5;
		break;

	case MSG_SW2CLCK:
		JobData.mode = mode;
		while(JobData.mode)
		{

		}
		break;

	case MSG_SW1LONG:
		KillTask(msg);
		break;

	case MSG_TIMEUP:
		SetLED(1,mode);
		KillTimer(ID[Data]);
		break;

	case MSG_DESTROY:
		TermThread(JobData.ThreadNo);
		println("Job2 Term");
		break;

	case MSG_ONSTDIN:
		MakeCmdText(&JobData.CMD);
		break;

	case MSG_COMMAND:
		OnCommand(JobData.CMD.text);
		break;

	default:
		return DefaultProc(msg, Msg, Data);
	}
}

static void lineprint(char No, char ** line)
{
	if(line[No])
	{
		print("Line ");
		PutCh(No+'1');
		print(" = ");
		println(line[No]);
	}
}

static void OnCommand(char * COMMAND)
{
	char * list[10];
	int i;

	for (i = 0; i < 10; i++) list[i] = 0;

	MakeList(COMMAND, list, ' ');

    for(i = 0; i < 10; i++)	lineprint(i, list);
}

