/*

	USB N9604 Rg[

	HID foCX@Keybord/Mouse Tv

*/

#include	<stdio.h>
#include	<string.h>
#include	"usbn9602.h"
#include	"3048.h"
#include	"usb.h"

//extern	void PrintSCI(const char *fmt, ...);		/* sci.c */

static void RegisterSet();
static void ResetUSB();
static void WakeupUSB();

static void rx0();
static void tx0();
static void tx1();
static void tx2();
static void tx3();
static void nako0();
static void naki0();

static void clrfeature();
static void setfeature();
static void getdescriptor();
static void send_desc_sub(void *ptr,int size);
static void send_desc();
static void getstatus();
static void setconfiguration();

static void SetStallUSB(int adr);
static void ClearStallUSB(int adr);
static void FlushRXC(int no);
static void FlushTXC(int no);
static void TxTogle(int no);

static void WriteUSB(int adr,int data);
static unsigned char ReadUSB(int adr);
static int ReadUSBBurst(int adr,int adr2,char *buff,int cnt);
static int WriteUSBBurst(int adr,int adr2,char *buff,int cnt);

/* HID */
static void setprotocol();
static void getprotocol();
static void setidle();
static void getidle();
static void setreport();
static void getreport();

/* USB Application */
static void InitUSBApp(void);
static void send_key(int port);
static void send_mouse(int port);


static	unsigned char	usbevent;					/* USB荞݃Cxg		*/
static	unsigned char	SETADDR;					/* AhXZbg 			*/
static	unsigned char	configno;					/* RtBO[VNO	*/
static	unsigned char	usbbuff[64];				/* ǂݍ݃obt@			*/
static	unsigned char	rx1buff[64];
static	unsigned char	rx2buff[64];
static	unsigned char	STALLD;						/* ECP̏				*/
static	unsigned char	DATA0_1;					/* USB_TXTGL̃tO		*/
static	char			senddesc;					/* 1 = fBXNv^M	*/
static	int				desc_size;					/* fBXNv^MTCY	*/
static	char			*desc_ptr;					/* fBXNv^|C^	*/


static	const unsigned char	epctbl[8] = {USB_EPC0,USB_EPC1,USB_EPC2,USB_EPC3,USB_EPC4,USB_EPC5,USB_EPC6,USB_EPC0};
static int	txcreg[4] = {USB_TXC0,USB_TXC1,USB_TXC2,USB_TXC3};
static int rxcreg[4] = {USB_RXC0,USB_RXC1,USB_RXC2,USB_RXC3};

/*------------------------------------------------------------*/
/*------------------------------------------------------------*/
static const unsigned char dev_desc[] = {
	0x12,				/* length of this desc.							*/
	0x01,				/* foCXEfBXNv^ 1 					*/
	0x00,0x01,			/* USB Version 1.0								*/
	0x00,				/* device class	NX					 	*/
	0x00,				/* device subclass								*/
	0x00,				/* device protocol								*/
	0x08,				/* EP0̍őpPbgTCY 						*/
	0xfe,0xff,			/* vendor ID	TvȂ̂łƂ肠		*/
	0x05,0x00,			/* product ID									*/
	0x01,0x00,			/* revision ID									*/
	0x01,				/* index of manuf. string						*/
	0x01,				/* index of prod.  string						*/
	0x02,				/* index of ser. # string						*/
	0x01				/* bNumConfigurations 							*/
};

static const char KeyReportDescriptor[] = {
	0x05, 0x01,                    /* USAGE_PAGE (Generic Desktop)			*/
/* Keybord Interfase */
	0x09, 0x06,                    /* USAGE (Keybord)						*/
	0xa1, 0x01,                    /* COLLECTION (Application)				*/

	0x05, 0x07,                    /*   USAGE Page (Keybord)				*/
	0x19, 0xE0,                    /*   Usage minimum(0=LeftControl)		*/
	0x29, 0xE7,                    /*   Usage maximum(7=RightGUI)			*/
	0x15, 0x00,                    /*     LOGICAL_MINIMUM (0)				*/
	0x25, 0x01,                    /*     LOGICAL_MAXIMUM (1)				*/

	0x95, 0x08,                    /*     REPORT_COUNT (8)					*/
	0x75, 0x01,                    /*     REPORT_SIZE (1)					*/
	0x81, 0x02,                    /*     INPUT (Data,Var,Abs)				*/

	0x95, 0x01,                    /*     REPORT_COUNT (1)					*/
	0x75, 0x08,                    /*     REPORT_SIZE (8)					*/
	0x81, 0x01,                    /*   INPUT (constant)					*/
	0x95, 0x03,                    /*   REPORT_COUNT (3)					*/
	0x75, 0x08,                    /*     REPORT_SIZE (8)					*/
	0x15, 0x00,                    /*     LOGICAL_MINIMUM (0)				*/
	0x25, 0x65,                    /*     LOGICAL_MAXIMUM (101)				*/

	0x05, 0x07,                    /* USAGE_PAGE (Keybord)					*/
	0x19, 0x00,                    /*   Usage minimum(Resarved)				*/
	0x29, 0x65,                    /*   Usage maximum(Keybord Application)	*/
	0x81, 0x00,                    /*   INPUT (Data, array)					*/

	0xc0                     	   /* END_COLLECTION						*/
};
static const char MouseReportDescriptor[] = {
	0x05, 0x01,                    /* USAGE_PAGE (Generic Desktop)			*/
/* Mouse Interfase */
	0x09, 0x02,                    /* USAGE (Mouse)							*/
	0xa1, 0x01,                    /* COLLECTION (Application)				*/

	0x09, 0x01,                    /*   USAGE Page (Pointer)				*/
	0xa1, 0x00,                    /* COLLECTION (Physical)					*/

	0x95, 0x03,                    /*   REPORT_COUNT (3)					*/
	0x75, 0x01,                    /*     REPORT_SIZE (1)					*/
	0x05, 0x09,                    /*	  USAGE_PAGE (Buttons)				*/
	0x19, 0x01,                    /*   Usage minimum(1)					*/
	0x29, 0x03,                    /*   Usage maximum(3)					*/
	0x15, 0x00,                    /*     LOGICAL_MINIMUM (0)				*/
	0x25, 0x01,                    /*     LOGICAL_MAXIMUM (1)				*/
	0x81, 0x02,                    /*     INPUT (Data,Var,Abs)				*/

	0x95, 0x01,                    /*   REPORT_COUNT (1)					*/
	0x75, 0x05,                    /*     REPORT_SIZE (5)					*/
	0x81, 0x01,                    /*     INPUT (constant)					*/
	0x75, 0x08,                    /*     REPORT_SIZE (8)					*/
	0x95, 0x03,                    /*     REPORT Count(3)					*/

	0x05, 0x01,                    /* USAGE_PAGE (Generic Desktop)			*/
	0x09, 0x30,                    /* USAGE (X)								*/
	0x09, 0x31,                    /* USAGE (Y)								*/
	0x09, 0x38,                    /* USAGE (Wheel)								*/

	0x15, 0x81,                    /*     LOGICAL_MINIMUM (-127)			*/
	0x25, 0x7F,                    /*     LOGICAL_MAXIMUM ( 127)			*/

	0x81, 0x06,                    /*   INPUT (Data, array)					*/
	0xc0,                          /* END_COLLECTION						*/
	0xc0	                       /* END_COLLECTION						*/
};

/* RtBO[VfBXNv^ */
static const unsigned char cfg_desc[] = {
	0x09,				/* length of this desc.							*/
	0x02,				/* RtBO[VEfBXNv^ 		  */
	9+9+9+7*1+9+9+7*1,	/* C^[tF[X^Gh|CgfBXNv^̍v CFG + IF + HID + EP*1 */
	0x00,				/* 												*/
	0x02,				/* C^[tF[X 2 						 */
	0x02,				/* RtBO[V 2					   */
	0x00,				/* index of config. string						*/
	0xc0,				/* attr.: self powered	D6=ȓd				*/
	250,				/*	;max power (500 mA)							*/
/*};*/
/*----------------------------------------------------------------------*/
/*static const unsigned char if_desc[] = {*/
	0x09,				/* length of this desc.							*/
	0x04,				/* INTERFACE descriptor							*/
	0x00,				/* interface number								*/
	0x00,				/* alternate setting							*/
	0x01,				/* # of (non 0) endpoints						*/
	0x03,				/* interface class								*/
	0x00,				/* interface subclass							*/
	0x00,				/* interface protocol							*/
	0x00,				/* index of intf. string						*/
/*};*/

/*static const unsigned char hid_desc[] = {*/
	0x09,				/* length of this desc.							*/
	0x21,				/* HID descriptor								*/
	0x00,0x01,			/* version										*/
	0x00,				/* Country Code (not use)						*/
	0x01,				/* Num HID descriptor (1)						*/
	0x22,				/* report descriptor							*/
	sizeof(KeyReportDescriptor),0,				/* HID descriptor size 							*/

/*static const unsigned char endp_desc[] = {*/
	/* pipe 0 */
	7,					/* length of this desc.							*/
	5,					/* ENDPOINT descriptor							*/
	0x81,				/* address (IN)									*/
	0x03,				/* attributes  (INTERRUPT)						*/
	0x40,0x00,			/* max packet size (64)							*/
	10,					/* interval (10ms)								*/
/*----------------------------------------------------------------------*/
/*static const unsigned char if_desc[] = {*/
	0x09,				/* length of this desc.							*/
	0x04,				/* INTERFACE descriptor							*/
	0x01,				/* interface number								*/
	0x00,				/* alternate setting							*/
	0x01,				/* # of (non 0) endpoints						*/
	0x03,				/* interface class								*/
	0x00,				/* interface subclass							*/
	0x00,				/* interface protocol							*/
	0x00,				/* index of intf. string						*/
/*};*/

/*static const unsigned char hid_desc[] = {*/
	0x09,				/* length of this desc.							*/
	0x21,				/* HID descriptor								*/
	0x00,0x01,			/* version										*/
	0x00,				/* Country Code (not use)						*/
	0x02,				/* Num HID descriptor (2)						*/
	0x22,				/* report descriptor							*/
	sizeof(MouseReportDescriptor),0,				/* HID descriptor size 							*/

/*static const unsigned char endp_desc[] = {*/
	/* pipe 0 */
	7,					/* length of this desc.							*/
	5,					/* ENDPOINT descriptor							*/
	0x82,				/* address (IN)									*/
	0x03,				/* attributes  (INTERRUPT)						*/
	0x40,0x00,			/* max packet size (64)							*/
	10,					/* interval (10ms)								*/
/*};*/

};

static const char lang_data[] = {
		4,3,9,4			/* LANGID (English)								*/
};

static const char mfg_str[] = {
		24,3,
		'U',0,'S',0,'B',0,'K',0,'E',0,'Y',0,'B',0,'O',0,'A',0,'R',0,'D',0,
};


static const char nbr_str[] = {
	8,3,
	'1',0,'.',0,'0',0,
};

static char	DESC_NO,DESC_TYPE,USB_IDLE,USB_PROT;			/* HID */


static void wait(int c)
{
	int		i,j;
	for(j=0;j<c;j++)
	{
		for(i=0;i<0x682;i++)
		{
		}
	}
}

/*------------------------------------------------------------*/
/* USB */
void InitUSB(void)
{
	long i;
	DESC_NO = 1;
	InitUSBApp();
	ResetUSB();
	RegisterSet();
	WakeupUSB();
	INTC.ISCR.BIT.IRQ5SC = 0;					/* IRQ_5 ݽ۰ف@Active Low  */
	INTC.IER.BIT.IRQ5E	 = 1;						/* IRQ5 Enable */
	EI;
	for(i = 0; i < 1000000; i++);
	DI;
}

static void RegisterSet()
{
	STALLD = 0;
	senddesc = 0;
	DATA0_1 = 0;
	SETADDR = 0;

	WriteUSB(USB_FAR,USB_AD_EN+0);				/* AhX	*/
	WriteUSB(USB_EPC0,USB_EP_EN);				/* EP0Ȱ		*/
	WriteUSB(USB_NAKMSK,USB_NAK_O0);			/* NAK MASK	*/
	WriteUSB(USB_TXMSK,USB_TXFIFO0+USB_TXFIFO1+USB_TXFIFO2+USB_TXFIFO3);	/* TX MASK */
	WriteUSB(USB_RXMSK,USB_RXFIFO0+USB_RXFIFO1+USB_RXFIFO2+USB_RXFIFO3);	/* RX MASK */
	WriteUSB(USB_ALTMSK,USB_SD3+USB_RESET_A);		/* ALT MASK */
	WriteUSB(USB_MAMSK,USB_INTR_E+USB_RX_EV+USB_NAK+USB_TX_EV+USB_ALT);		/* MAIN MASK */
	FlushTXC(0);
	FlushTXC(1);
	FlushTXC(2);
	FlushTXC(3);
	WriteUSB(USB_TXC1,0);
	WriteUSB(USB_TXC2,0);
	WriteUSB(USB_RXC0,USB_RX_EN);				/* RX0Ȱ		*/
}

static void ResetUSB()
{
	WriteUSB(USB_MCNTRL,USB_SRST+USB_VGE);				/* USBZbg 3.3V */
	wait(100);								/* 100msec */
	WriteUSB(USB_MCNTRL,USB_INT_L_P+USB_VGE);			/* ݂active low push pull */
	WriteUSB(USB_CCONF,USB_CLKDIV-1);					/* 48MHz/4 = 12MHz */
}

static void WakeupUSB()
{
	WriteUSB(USB_NFSR,USB_OPR_ST);					/* ɂ */
	WriteUSB(USB_MCNTRL,USB_INT_L_P+USB_NAT+USB_VGE);		/* USBɰނ𓮍ɂ */
}

/* USB|[gf[^\ */
/* [hƁAXe[^Xς郌WX^̂Œ */
void DispUSBPort()
{
		int		i,j;
/*		PrintSCI("00 01 02 03 04 05 06 07 08 09 0A 0B 0C 0D 0E 0F\n");  */
		for(j=0;j<4;j++)
		{
/*			for(i=0;i<16;i++)
				PrintSCI("%02X ",ReadUSB(i+j*16));
			PrintSCI("\n");   */
		}
}

/*------------------------------------------------------------*/
/* USB荞 */
#ifdef	__GNUC__
void int_irq5()  __attribute__ ((interrupt_handler));
#endif
void int_irq5()
{
	unsigned char	nakevent,rxevent,txevent,altevent;
	char	reg;


	usbevent = ReadUSB(USB_MAEV);

	if( usbevent != 0 )
	{
	}
	if( usbevent & USB_NAK )
	{
		nakevent = ReadUSB(USB_NAKEV);
		if( nakevent & USB_NAK_O0 )
		{
			nako0();
		}
		if( nakevent & USB_NAK_I0 )
		{
			naki0();
		}
	}
	else if( usbevent & USB_RX_EV )
	{
		rxevent = ReadUSB(USB_RXEV);
		if( rxevent & USB_RXFIFO0 )
		{
			rx0();
		}
	}
	else if( usbevent & USB_TX_EV )
	{
		txevent = ReadUSB(USB_TXEV);
		if( txevent & USB_TXFIFO0 )
		{
			tx0();
		}
		else if( txevent & USB_TXFIFO1 )
		{
 			tx1();
		}
		else if( txevent & USB_TXFIFO2 )
		{
			tx2();
		}
	}
	else if( usbevent & USB_ALT )
	{
		altevent = ReadUSB(USB_ALTEV);
		if( altevent & USB_RESET_A )
		{
			/* Zbg */
			RegisterSet();
			WakeupUSB();
		}
		else if( altevent & USB_SD3 )
		{
			/* TXyh */
			WriteUSB(USB_ALTMSK,USB_RESUME_A+USB_RESET_A);	/* ALTMSK		*/
			WriteUSB(USB_NFSR,USB_SUS_ST);			/* ɰނ	*/

		}
		else if( altevent & USB_RESUME_A )
		{
			/* W[ */
			WriteUSB(USB_ALTMSK,USB_SD3+USB_RESET_A);		/* ALTMSK			*/
			WriteUSB(USB_NFSR,USB_OPR_ST);				/* ɰނ𓮍\ɂ	*/
		}
	}
}

/*==========================================================================
							RXCxg̏
==========================================================================*/
/* RX0(system) */
/*
 NGXgR[h̎擾
		0 byte
			D7 ... f[^ 0=zXg->foCX , 1=foCX->zXg
			D6-D5 ... ^Cv
					0:W , 1:NX , 2:x_ , 3:\
			D4-D0 ... M
					0:foCX , 1:C^[tFCX , 2:Gh|Cg , 3:̑
		1 byte
			̃NGXg
		2 byte
			value
		2 byte
			index
		2 byte
			length
*/
static void rx0()
{
	unsigned char	rxstat;
	rxstat = ReadUSB(USB_RXS0);
	if( rxstat & USB_SETUP_RX )
	{
		ReadUSBBurst(USB_RXD0,USB_RXS0,(char*)usbbuff,8);
		FlushRXC(0);
		FlushTXC(0);
		ClearStallUSB(USB_EPC0);
		if( (usbbuff[0] & 0x60) == 0 )
		{
			/* WNGXg */
			switch( usbbuff[1] )
			{
				case	USB_CLEAR_FEATURE :
					clrfeature();
					break;
				case	USB_GET_CONFIGURATION :
					WriteUSB(USB_TXD0,configno);
					break;
				case	USB_GET_DESCRIPTOR :
					getdescriptor();
					break;
				case	USB_GET_STATUS :
					getstatus();
					break;
				case	USB_GET_INTERFACE :
					WriteUSB(USB_TXD0,0);
					break;
				case	USB_SET_ADDRESS :
					WriteUSB(USB_EPC0,USB_DEF);
					SETADDR = usbbuff[2]|USB_AD_EN;
					WriteUSB(USB_FAR,SETADDR);
					break;
				case	USB_SET_CONFIGURATION :
					setconfiguration();
					break;
				case	USB_SET_FEATURE :
					setfeature();
					break;
				case	USB_SET_INTERFACE :
					if( usbbuff[2] != 0 )
						SetStallUSB(USB_EPC0);
					break;
				default :
					/* ` */
					SetStallUSB(USB_EPC0);
					break;
			}
		}
		else if( (usbbuff[0] &0x60 ) ==  0x20 )
		{
			/* NXNGXg */
			switch( usbbuff[1] )
			{
				case	USB_GET_REPORT :
					getreport();
					break;
				case	USB_GET_IDLE :
					getidle();
					break;
				case	USB_GET_PROTOCOL :
					getprotocol();
					break;
				case	USB_SET_REPORT :
					setreport();
					break;
				case	USB_SET_IDLE :
					setidle();
					break;
				case	USB_SET_PROTOCOL :
					setprotocol();
					break;
				default :
					SetStallUSB(USB_EPC0);
					break;
			}
		}
		else if( (usbbuff[0] &0x60 ) ==  0x40 )
		{
			/* x_NGXg */
			SetStallUSB(USB_EPC0);
		}
		else
		{
			/* ` */
			SetStallUSB(USB_EPC0);
		}
		DATA0_1 |= 1;	/* SETUPȂ̂ް̗LɊ֌WDATA1ƂđM */
		TxTogle(0);
	}
	else
	{
		if( senddesc )
		{
			senddesc = 0;
		}
		FlushTXC(0);
		WriteUSB(USB_RXC0,USB_RX_EN);
	}
}


/*==========================================================================
							TXCxg̏
==========================================================================*/
/* TX0 MI */
static void tx0()
{
	unsigned char	txstat;
	txstat = ReadUSB(USB_TXS0);
	if( (txstat & USB_ACK_STAT) && (txstat & USB_TX_DONE) )
	{
		/* ok */
		FlushTXC(0);
		if( senddesc )
		{
			send_desc();
			TxTogle(0);					/* TX0M */
		}
		else
		{
			WriteUSB(USB_RXC0,USB_RX_EN);	/* RX0M */
		}
	}
	else
	{
		/* error ? */
	}
}

/*------------------------------------------------------------*/
/* TX2MI */
static void tx1()
{
	unsigned char	txstat;
	txstat = ReadUSB(USB_TXS1);
	if( (txstat & USB_ACK_STAT) && (txstat & USB_TX_DONE) )
	{
		send_key(USB_TXD1);
		TxTogle(1);
	}
	else
	{
		/*
			TCY菬ǂݍ݂sꂽꍇAɂꍇ
		*/
	}
}

/*------------------------------------------------------------*/
/* TX2MI */
static void tx2()
{
	unsigned char	txstat;
	txstat = ReadUSB(USB_TXS2);
	if( (txstat & USB_ACK_STAT) && (txstat & USB_TX_DONE) )
	{
		send_mouse(USB_TXD2);
		TxTogle(2);
	}
	else
	{
		/*
			TCY菬ǂݍ݂sꂽꍇAɂꍇ
		*/
	}
}
/*------------------------------------------------------------*/
/* TX3MI */
static void tx3()
{
	unsigned char	txstat;
	txstat = ReadUSB(USB_TXS3);
	if( (txstat & USB_ACK_STAT) && (txstat & USB_TX_DONE) )
	{
		TxTogle(3); /**/
	}
	else
	{
		/*
			TCY菬ǂݍ݂sꂽꍇAɂꍇ
		*/
	}
}
/*==========================================================================
							NAKCxg̏
==========================================================================*/
/*
	NAKCxǵAG[ꍇȂǍđMꍇ
	NAK0ENABLEɂĂȂ̂ŁAȊO͏
*/
static void nako0()
{
}
static void naki0()
{
}



/*==========================================================================
							WNGXg̏
==========================================================================*/
/* I@ */
static void clrfeature()
{
	if( (usbbuff[0] & 3) == 2 )
	{
		/* Gh|Cgf[^ */
		if((usbbuff[3]&7) != 0 )
			ClearStallUSB(epctbl[usbbuff[3]&7]);
		STALLD &= -1 ^ (1<<(usbbuff[3]&7));
	}
}
static void setfeature()
{
	if( (usbbuff[0]&3) == 2 )		/* ENDPOINT */
	{
		/* Gh|Cgf[^ */
		if((usbbuff[3]&7) != 0 )
			SetStallUSB(epctbl[usbbuff[3]&7]);
		STALLD |= (1<<(usbbuff[3]&7));
	}
}

/*------------------------------------------------------------*/
/* fBXNv^Ԃ */
static void getdescriptor()
{
	DATA0_1 &= 0xfe;

	switch( usbbuff[3] )
	{
		case	USB_DEVICE :
			send_desc_sub((void*)dev_desc,dev_desc[0]);
			break;

		case	USB_CONFIGURATION :
			send_desc_sub((void *)cfg_desc,cfg_desc[2]);
			break;

		case	USB_HID :
			break;

		case	USB_HIDREPORT :
			switch(usbbuff[4]){
			case 0:
				send_desc_sub((void *)KeyReportDescriptor,
							  sizeof(KeyReportDescriptor)
							  );  /**/
				break;

			case 1:
				send_desc_sub((void *)MouseReportDescriptor,
							  sizeof(MouseReportDescriptor)
							  );    /**/
				break;
			}
			break;

		case	USB_XSTRING :
		{
			switch( usbbuff[2] )
			{
				case	0 :
					send_desc_sub((void *)lang_data,lang_data[0]);
					break;
				case	1 :
					send_desc_sub((void *)mfg_str,mfg_str[0]);
					break;
				case	2 :
					send_desc_sub((void *)nbr_str,nbr_str[0]);
					break;
			}
			break;
		}
		default :
		{
		}
	}
}

static void send_desc_sub(void *ptr,int size)
{
	desc_size = (usbbuff[7] << 8) + usbbuff[6];
	if( desc_size > size )	desc_size = size;	/* Mvobt@ȏ̓f[^𑗂Ȃ */
	desc_ptr = ptr;
	senddesc = 1;								/* fBXNv^MtO𗧂Ă */
	send_desc();
}

static void send_desc()
{
	int		sz;
	sz = 8;
	if( desc_size == 0 )	return;
	if( desc_size <= 8 )	sz = desc_size;
	sz = WriteUSBBurst(USB_TXD0,USB_TXS0,desc_ptr,sz);
	desc_size -= sz;
	desc_ptr += sz;
	if( desc_size == 0 )	senddesc = 0;
}
/*------------------------------------------------------------*/
/* Xe[^X */
static void getstatus()
{
	int		data,ep;
	data = usbbuff[0]&3;
	if( (data == 0) || (data == 1) )		/* DEVICE,INTERFACE */
	{
		WriteUSB(USB_TXD0,0);
		WriteUSB(USB_TXD0,0);
	}
	else if( data== 2)						/* Gh|Cg */
	{
		ep = usbbuff[3]&7;
		/* epSTALLԂ𑗐M */
		if( STALLD & (1<<ep) )	WriteUSB(USB_TXD0,1);
		else					WriteUSB(USB_TXD0,0);
	}
	else
	{
		WriteUSB(USB_TXD0,0);
	}
}

/*------------------------------------------------------------*/
static void setconfiguration()
{
	configno = usbbuff[2];
	if( configno == 0 )
	{
		WriteUSB(USB_EPC1,0);				/* EPC1gps */
		WriteUSB(USB_EPC2,0);				/* EPC2gps */
		WriteUSB(USB_EPC3,0);				/* EPC3gps */
		WriteUSB(USB_EPC4,0);				/* EPC4gps */
		WriteUSB(USB_EPC5,0);				/* EPC5gps */
		WriteUSB(USB_EPC6,0);				/* EPC6gps */
	}
	else
	{
		STALLD = 0;
		FlushTXC(1);
		FlushTXC(2);
		FlushTXC(3);
		WriteUSB(USB_EPC1,USB_EP_EN+01);			/* EPC1ڽ1ƂĲȰ */
		WriteUSB(USB_EPC3,USB_EP_EN+02);			/* EPC3ڽ2ƂĲȰ */
		WriteUSB(USB_EPC5,USB_EP_EN+03);			/* EPC5ڽ3ƂĲȰ */
		WriteUSB(USB_TXC1,USB_TX_EN|USB_TX_LAST);				/* TX1M */
		WriteUSB(USB_TXC2,USB_TX_EN|USB_TX_LAST);				/* TX2M */
		WriteUSB(USB_TXC3,USB_TX_EN|USB_TX_LAST);				/* TX3M */
	}
}

/*==========================================================================
							HIDNX^NGXg
==========================================================================*/


static void getreport()
{
	int txevent;

	DESC_TYPE = usbbuff[3];
	/* HID𑗐M */
	switch(DESC_TYPE){
	case 1:
		send_key(USB_TXD1);
		TxTogle(1);
		break;
	case 2:
		send_mouse(USB_TXD2);
		TxTogle(2);
		break;
	case 3:
		TxTogle(3);     /**/
		break;
	}
}

static void setreport()
{
	DESC_TYPE = usbbuff[3];
}

static void getidle()
{
	WriteUSB(USB_TXD0,USB_IDLE);
}

static void setidle()
{
	USB_IDLE = usbbuff[3];
}

static void getprotocol()
{
	WriteUSB(USB_TXD0,USB_PROT);
}

static void setprotocol()
{
	USB_PROT = usbbuff[2];
}


/*==========================================================================
								ėp[`
==========================================================================*/
/* STALL̃ZbgƃNA */
static void SetStallUSB(int adr)
{
	WriteUSB(adr,ReadUSB(adr) | 0x80);
}

static void ClearStallUSB(int adr)
{
	WriteUSB(adr,ReadUSB(adr)&0x7f);
}

/* FIFÕtbV */
static void FlushRXC(int no)
{
	WriteUSB(rxcreg[no],USB_FLUSH);
}

static void FlushTXC(int no)
{
	int		d;
	d = ReadUSB(txcreg[no]);
	d |= USB_FLUSH;
	WriteUSB(txcreg[no],d);
}

/* MItOZbg */
/* reg = USB_TXC0`6	*/
static void TxTogle(int no)
{
	unsigned char	d;
	d = USB_TX_EN;
	if( DATA0_1 & (1<<no) )	d |= USB_TX_TOGL;
	else					d &= ~USB_TX_TOGL;
	d |= USB_TX_LAST;
	WriteUSB(txcreg[no],d);
	DATA0_1 ^= (1<<no);
}

/*------------------------------------------------------------*/
/* USB̃AhXǂݍ */
static unsigned char ReadUSB(int adr)
{
	USB9602R = (unsigned char)adr;
	return( USB9602D );
}
/* USB̃AhX֏ */
static void WriteUSB(int adr,int data)
{
	USB9602R = (unsigned char)adr;
	USB9602D = (unsigned char)data;
}


/* o[Xgg] */
static int ReadUSBBurst(int adr,int adr2,char *buff,int cnt)
{
	int		i;
	int		rcnt;
	USB9602R = (unsigned char)adr;
	for(rcnt=0,i=0;i<cnt;i++)
	{
		if( (ReadUSB(adr2) & 0xf) == 0 )	break;

		USB9602R = (unsigned char)adr;
		*buff = USB9602D;
		buff++;
		rcnt++;
	}
	return(rcnt);
}

static int WriteUSBBurst(int adr,int adr2,char *buff,int cnt)
{
	int		i,scnt;
	for(scnt=0,i=0;i<cnt;i++)
	{
		if( (ReadUSB(adr2) & 0x1f) == 0 )	break;

		USB9602R = (unsigned char)adr;
		USB9602D = *buff;
		buff++;
		scnt++;
	}
	return(scnt);
}

/*==========================================================================
							JOYSTICKf[^M
==========================================================================*/
/*
	f[^A{^f[^𑗐M܂B
	XCb`擾ĕƁA{^ƂđMĂ܂B
	Rg[pl̃Q[IvṼvpeBŃ`FbNł܂B
*/

#define KEY_MAX 5

static char keybak[KEY_MAX];

KeyData KEY;

char 	PosX, PosY, Howeel, SwData;

extern	int GetSW(int no);					/* main.c */

static void InitUSBApp(void)
{
	int i;

	PosX = 0;
	PosY = 0;
	Howeel=0;
	SwData=0;

	for (i = 0; i < KEY_MAX; i++) {
		keybak[i] = 0;
		KEY.BUFFER[i] = 0;
	}

}

static void send_key(int port)
{
	char	i;

	for (i = 0; i < KEY_MAX; i++) {
		if (keybak[i] != KEY.BUFFER[i]) break;
	}

	if (i < KEY_MAX) {
		for(i = 0; i < KEY_MAX; i++)
		{
			WriteUSB(port,KEY.BUFFER[i]);
			keybak[i] = KEY.BUFFER[i];
            KEY.BUFFER[i] = 0;
		}
	}
}

static void send_mouse(int port)
{
	WriteUSB(port,SwData);
	WriteUSB(port,PosX);
	WriteUSB(port,PosY);
	WriteUSB(port,Howeel);/**/
	PosX = 0;
	PosY = 0;
	Howeel = 0;

}

