//---------------------------------------------------------------------------
#include "sros.h"
#include "OSCore.h"
#include "device3.h"
#include "3048.h"
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//  LN^[foCXhCo֐ `
//---------------------------------------------------------------------------
/***************************************************

	LN^[foCXhCo֐

 ***************************************************/

 static int DevNo;

 static DEVICE dev;

//---------------------------------------------------------------------------
//  [U[C^[tF[X
//---------------------------------------------------------------------------
/*
	hCoɍ킹ĖOςĂB
	͐pAo͐p@̏ꍇ̓R[h폜ĂB
*/
static BYTE Flag;
static char Data;
static char Inp;

char GetPaipe(void)
{
	if((Flag & 0x02)==0)
	{
		Flag |= 2;
		return Inp;
	}
	return -1;
}

void PutPaipe(char c)
{
	Data = c;
	Flag |= 1;
}

BOOL EmptyReadBufPaipe(void)
{
	return EmptyReadBuf(DevNo);
}

BOOL EmptyWriteBufPaipe(void)
{
	return EmptyWriteBuf(DevNo);
}

void PrintPaipe(char * msg)
{
	int i;

	i = 0;
	while(msg[i])
	{
        PutPaipe(msg[i]);
    }
}

void ControlPaipe(char * msg)
{
	if(StrPos(msg, "CLAR") > -1)
	{
		dev.Buffer[0].count = 0;
		dev.Buffer[1].count = 0;
		dev.Buffer[0].top = 0;
		dev.Buffer[1].top = 0;
	}
}

//---------------------------------------------------------------------------
//  hCoC^[tF[X
//---------------------------------------------------------------------------
static BOOL RD_Ready(void)
{
	return Flag & 0x01;
}

static char IRQ_Read(void)
{
	return Data;
}

static BOOL WR_Ready(void)
{
	return Flag & 0x02;
}

static void IRQ_Write(char c)
{
	Inp = c;
	Flag &= 0xFD;
}

//---------------------------------------------------------------------------
//  [`
//---------------------------------------------------------------------------
static void InitDEV(void)
{
	Flag = 0x02;
}

static void Free(void)
{
	SetDevice(DevNo, 0);
}

void AddPaipe(int No)
{
	int i;

	DevNo = No;
	dev.Init		= InitDEV;
	dev.Ctrl		= ControlPaipe;

	dev.IRQ_ReadDevice = IRQ_Read;
	dev.RD_Ready	= RD_Ready;

	dev.IRQ_WriteDevice = IRQ_Write;
	dev.WR_Ready	= WR_Ready;
	dev.Free		= Free;

	dev.Buffer[0].count = 0;
	dev.Buffer[1].count = 0;
	dev.Buffer[0].top   = 0;
	dev.Buffer[1].top   = 0;

	for(i = 0; i < MAX_BUFFER; i++)
	{
		dev.Buffer[0].buf[i] = 0;
		dev.Buffer[1].buf[i] = 0;
	}
	SetDevice(DevNo, &dev);

}
